# Uses of Class
com.fasterxml.jackson.core.type.TypeReference

Packages that use TypeReference
Package
Description
com.fasterxml.jackson.core
Main public API classes of the core streaming JSON processor: most importantly `JsonFactory` used for constructing JSON parser (`JsonParser`) and generator (`JsonGenerator`) instances.
com.fasterxml.jackson.core.type
Contains classes needed for type introspection, mostly used by data binding functionality.

## Uses of TypeReference in com.fasterxml.jackson.core

Methods in com.fasterxml.jackson.core with parameters of type TypeReference
Modifier and Type
Method
Description
`abstract <T> T`
ObjectCodec.`readValue(JsonParser p, TypeReference<T> valueTypeRef)`
Method to deserialize JSON content into a Java type, reference to which is passed as argument.
`<T> T`
JsonParser.`readValueAs(TypeReference<?> valueTypeRef)`
Method to deserialize JSON content into a Java type, reference to which is passed as argument.
`abstract <T> Iterator<T>`
ObjectCodec.`readValues(JsonParser p, TypeReference<T> valueTypeRef)`
Method for reading sequence of Objects from parser stream, all with same specified value type.
`<T> Iterator<T>`
JsonParser.`readValuesAs(TypeReference<T> valueTypeRef)`
Method for reading sequence of Objects from parser stream, all with same specified value type.

## Uses of TypeReference in com.fasterxml.jackson.core.type

Methods in com.fasterxml.jackson.core.type with parameters of type TypeReference
Modifier and Type
Method
Description
`int`
TypeReference.`compareTo(TypeReference<T> o)`
The only reason we define this method (and require implementation of `Comparable`) is to prevent constructing a reference without type information.